from Shynatime import ShTime
from ShynaProcess import ShynaNews
from ShynaDatabase import Shdatabase
import mysql.connector
import os
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize


class ShynaNewsAutomation:
    s_time = ShTime.ClassTime()
    s_news = ShynaNews.ShynaNews()
    s_data = Shdatabase.ShynaDatabase()
    database_user = 'pythoqdx_Shyna'
    default_database = 'pythoqdx_Shyna'
    host = os.environ.get('host')
    passwd = os.environ.get('passwd')
    keyword_list = []
    stop_words = set(stopwords.words('english'))
    custom_ignore_keyword_list = ['the', 'how','call','high','says','why','study','full', 'team', 'check', 'players', 'top', 'may', 'key', 'govt', 'new', 'year', 'list', 'man', 'squad']
    
    def get_news(self):
        try:
            self.s_data.query = "SELECT news_urls, host_name from news_url"
            result = self.s_data.select_from_table()
            for item in result:
                self.s_news.url = item[0]
                if str(item[1]).lower().__eq__('indiatimes'):
                    print("Getting News from India Times Server")
                    for key, value in self.s_news.get_news_toi().items():
                        self.insert_news_in_database(news_title=str(key), news_summary=str(value[0]), news_link=str(value[1]), news_date=value[2], news_time=value[3], publish_date_time=str(value[2])+" "+str(value[3]))
                else:
                    print("Getting News from Zee News Server")
                    for key, value in self.s_news.get_news_zee().items():
                        self.insert_news_in_database(news_title=str(key), news_summary=str(value[0]), news_link=str(value[1]), news_date=value[2], news_time=value[3], publish_date_time=str(value[2])+" "+str(value[3]))
        except Exception as e:
            print(e)
        finally:
            self.update_news_keyword()
    
    def insert_news_in_database(self,news_title, news_summary, news_link,news_date, news_time, publish_date_time):
        try:
            print("Entering insert_news_in_database")
            mydb = mysql.connector.connect(
                host=self.host,
                user=self.database_user,
                passwd=self.passwd,
                database=self.default_database
            )
            mycursor = mydb.cursor()
            mycursor.execute("INSERT INTO news_alert (news_title, news_description, news_time, news_date, news_link, task_date, task_time, publish_date_time) \
                VALUES (%s, %s, %s, %s, %s, %s, %s, %s )", (str(news_title), str(news_summary), str(news_time),str(news_date), str(news_link), str(self.s_time.now_date), str(self.s_time.now_time), str(publish_date_time)))
            mydb.commit()
        except Exception as e:
            print(e)
        finally:
            mydb.close()
            self.s_data.set_date_system(process_name="news_details")
    
    def update_news_keyword(self):
        keyword_list_result = []
        count_list = []
        try:
            self.s_data.query = "SELECT news_keyword, repeat_count from news_keyword where look_status_from_master='True'"
            result = self.s_data.select_from_table()
            if str(result[0]).lower().__eq__('empty'):
                keyword_list_result = []
            else:
                for item in result:
                    keyword_list_result.append(item)
            self.s_data.query = "Select news_title, count from news_alert where keyword_process='False'"
            result = self.s_data.select_from_table()
            if str(result[0]).lower().__eq__('empty'):
                print("No keywords for analysis")
            else:
                for item in result:
                    count_list.append(item[1])
                    word_tokens = word_tokenize(str(item[0]).lower())
                    for keyword in [w for w in word_tokens if not w in self.stop_words]:
                        keyword = "".join(e for e in keyword if e.isalpha())
                        if len(keyword) > 1:
                            self.keyword_list.append(keyword)
                self.keyword_list = {i: self.keyword_list.count(i) for i in self.keyword_list}
                for key, value in sorted(self.keyword_list.items()):
                    if int(value) < 4 or key in self.custom_ignore_keyword_list or len(str(key))< 2:
                        # print("Deleting", key)
                        del self.keyword_list[key]
                for key, value in self.keyword_list.items():
                    for keywords in keyword_list_result:
                        if key == keywords[0] and int(value) > int(keywords[1]):
                            self.keyword_list.update({key: value})
                        else:
                            self.keyword_list.update({keywords[0]: keywords[1]})
            for key, val in self.keyword_list.items():
                self.s_data.query = "INSERT INTO news_keyword (news_keyword,repeat_count) VALUES('"+str(key)+"','"+str(val)+"') ON DUPLICATE KEY UPDATE repeat_count='"+str(val)+"'"
                self.s_data.create_insert_update_or_delete()
            counts = str(count_list).replace('[', '(').replace(']', ')')
            self.s_data.query = "Update news_alert set keyword_process = 'True' where count in "+str(counts)
            self.s_data.create_insert_update_or_delete()
        except Exception as e:
            print(e)
        finally:
            self.s_data.set_date_system(process_name="news_keyword_details")


if __name__ == "__main__":
    ShynaNewsAutomation().get_news()